﻿Imports System.Data

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            Dim bfield As New BoundField()
            bfield.HeaderText = "Name"
            bfield.DataField = "Name"
            GridView1.Columns.Add(bfield)

            Dim tfield As New TemplateField()
            tfield.HeaderText = "Country"
            GridView1.Columns.Add(tfield)

            tfield = New TemplateField()
            tfield.HeaderText = "View"
            GridView1.Columns.Add(tfield)
        End If
        Me.BindGrid()
    End Sub

    Private Sub BindGrid()
        Dim dt As New DataTable()
        dt.Columns.AddRange(New DataColumn(2) {New DataColumn("Id", GetType(Integer)), New DataColumn("Name", GetType(String)), New DataColumn("Country", GetType(String))})
        dt.Rows.Add(1, "John Hammond", "United States")
        dt.Rows.Add(2, "Mudassar Khan", "India")
        dt.Rows.Add(3, "Suzanne Mathews", "France")
        dt.Rows.Add(4, "Robert Schidner", "Russia")
        GridView1.DataSource = dt
        GridView1.DataBind()
    End Sub

    Protected Sub OnRowDataBound(sender As Object, e As GridViewRowEventArgs)
        If e.Row.RowType = DataControlRowType.DataRow Then
            Dim txtCountry As New TextBox()
            txtCountry.ID = "txtCountry"
            txtCountry.Text = TryCast(e.Row.DataItem, DataRowView).Row("Country").ToString()
            e.Row.Cells(1).Controls.Add(txtCountry)

            Dim lnkView As New LinkButton()
            lnkView.ID = "lnkView"
            lnkView.Text = "View"
            AddHandler lnkView.Click, AddressOf ViewDetails
            lnkView.CommandArgument = TryCast(e.Row.DataItem, DataRowView).Row("Id").ToString()
            e.Row.Cells(2).Controls.Add(lnkView)
        End If
    End Sub

    Protected Sub ViewDetails(sender As Object, e As EventArgs)
        Dim lnkView As LinkButton = TryCast(sender, LinkButton)
        Dim row As GridViewRow = TryCast(lnkView.NamingContainer, GridViewRow)
        Dim id As String = lnkView.CommandArgument
        Dim name As String = row.Cells(0).Text
        Dim country As String = TryCast(row.FindControl("txtCountry"), TextBox).Text
        ClientScript.RegisterStartupScript(Me.[GetType](), "alert", (Convert.ToString((Convert.ToString((Convert.ToString("alert('Id: ") & id) + " Name: ") & name) + " Country: ") & country) + "')", True)
    End Sub
End Class

